import * as _heroui_system from '@heroui/system';
import { HTMLHeroUIProps } from '@heroui/system';
import { HTMLMotionProps } from 'framer-motion';
import react__default from 'react';

interface NavbarMenuProps extends HTMLHeroUIProps<"ul"> {
    children?: react__default.ReactNode;
    /**
     * The container element in which the navbar menu overlay portal will be placed.
     * @default document.body
     */
    portalContainer?: Element;
    /**
     * The props to modify the framer motion animation. Use the `variants` API to create your own animation.
     */
    motionProps?: Omit<HTMLMotionProps<"ul">, "ref">;
}
declare const NavbarMenu: _heroui_system.InternalForwardRefRenderFunction<"ul", NavbarMenuProps, never>;

export { type NavbarMenuProps, NavbarMenu as default };
